#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_handle4xi.py">
#<abstract4xi abstract = "providing function reduce_handle4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'reduce_handle4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import traceback         
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass

#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from popen4xi import Popen4Xi
from duplicate4xi import duplicate4xi
from _get_listener4xi import _get_listener4xi
from _cache4xi import add_cache4xi

from print4xi import print4xi
from time4xi import time4xi
#"
#/>

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_handle4xi" usage = "
#   reduce_connection4xi.py:
#       rh2xi = reduce_handle4xi(conn.fileno())
#   reduce_pipe_connection4xi.py:
#       rh2xi = reduce_handle4xi(conn.fileno())
#   reduction.py:
#       rh = reduce_handle(conn.fileno())
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reduce_handle4xi(handle):
    '''
    reduce_handle4xi in reduction.py by reduce_connection function: rh = reduce_handle(conn.fileno())
    '''
            
    # -----------------------------------------------------------------------------------------    
    # (Step 1/5)
    # -----------------------------------------------------------------------------------------        
        
    class2print = "reduce_handle4xi"
    method2print = "reduce_handle4xi"
 
    message2print = "{(Step 1/5a) started" + "; reduce-handle4xi-started: " + str(reduce_handle4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/5a) passed" + "; handle-passed-to-reduce-handle4xi: " + str(handle) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
    try:
        if Popen4Xi.thread_is_spawning():
        
            message2print = "{(Step 1/5b) passing" + "; handle-passing-to-Popen4Xi-duplicate-for-child-by-reduce-handle4xi: " + str(handle) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            
            message2print = "{(Step 1/5c) returning" + "; Popen4Xi-duplicate-for-child-function-returning-by-reduce-handle4xi: " + str(Popen4Xi.duplicate_for_child) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                      
        
        
            return (None, Popen4Xi.duplicate_for_child(handle), True)
    except:
        message2print = "{(Step 1/5d) yielded" + "; Popen4Xi-yielded-by-reduce-handle4xi: " + str(Popen4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
                
        
    # -----------------------------------------------------------------------------------------    
    # (Step 2/5)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 2/5a) passing" + "; handle-passing-to-duplicate4xi-by-reduce-handle4xi: " + str(handle) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
            
    dup_handle2xi = duplicate4xi(handle) #forking-one
    
    message2print = "{(Step 2/5b) set" + "; dup-handle2xi-set-by-reduce-handle4xi to: " + str(dup_handle2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    # -----------------------------------------------------------------------------------------    
    # (Step 3/5)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 3/5a) passing" + "; dup-handle2xi-passing-to-add-cache4xi-by-reduce-handle4xi: " + str(dup_handle2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
            
    add_cache4xi(dup_handle2xi)
    
    message2print = "{(Step 3/5b) performed" + "; add-cache4xi-performed-by-reduce-handle4xi: " + str(add_cache4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
              
    # -----------------------------------------------------------------------------------------    
    # (Step 4/5)
    # -----------------------------------------------------------------------------------------        
    
    l2xi = _get_listener4xi()
    
    message2print = "{(Step 4/5) set" + "; l2xi-set-by-reduce-handle4xi to: " + str(l2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # -----------------------------------------------------------------------------------------    
    # (Step 5/5)
    # -----------------------------------------------------------------------------------------     
    message2print = "{(Step 5/5a) returning" + "; l2xi-address-returning-by-reduce-handle4xi: " + str(l2xi.address) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
            
    message2print = "{(Step 5/5b) returning" + "; dup-handle2xi-returning-by-reduce-handle4xi: " + str(dup_handle2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{(Step 5/5c) returning" + "; False-returning-by-reduce-handle4xi: " + str(False) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
                
    
    return (l2xi.address, dup_handle2xi, False)
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_handle4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

